#!/usr/bin/env perl

# deleteImage.pl
# iChat pictures manager

use strict;
my ($theFolder,$theImage) = splitFolderFromFile(shift @ARGV);

if (!(-d $theFolder)) {
  print 'Recent images folder not found: '.$theFolder;
  exit;
}

my @imgs = readImages($theFolder.'Recents.plist');

local *F;
my($img,$i);
open F,">$theFolder\Recents.plist" or do { print "Recent.plist cannot be written"; exit };
foreach $i (@imgs) {
  $img = '';
  $i =~ m,\<key\>original\</key\>[\r\n\t]+\<string\>([^\<]+)\</string\>, and $img = $1;
  $img ne $theImage and print F $i;
}
close F;

sub readImages {
  local *F;
  my ($riga,@risp,$cnt);
  my $inf = shift or return @risp;
  open F,"<$inf" or return @risp;
  $riga = <F>;
  while ($riga !~ m,\<dict\>,) {
    $risp[0] .= $riga;
    $riga = <F>;
  }
  while ($riga !~ m,\</array\>,) {
    $cnt++;
    while ($riga !~ m,\</dict\>,) {
      $risp[$cnt] .= $riga;
      $riga = <F>;
    }
    $risp[$cnt] .= $riga;
    $riga = <F>;
  }
  $cnt++;
  $risp[$cnt] .= $riga;
  while ($riga=<F>) {
    $risp[$cnt] .= $riga;
  }
  close F;
  return @risp;
}

sub splitFolderFromFile {
  my $i = shift or return ('','');
  $i =~ m,^(.*)/([^/]+)$, and return ($1.'/',$2);
  return ('',$i);
}
